commit 453486236871cd2aedd91619e00e09b74b47fee1
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Tue Jul 30 01:16:25 2024 +0530

    PS-9301 PSI_THREAD_INFO not updated while executing PREPARED STATEMENTS
    
    https://perconadev.atlassian.net/browse/PS-9301
    
    Bug#33057164 mysql/mysql-server@987fc9a5ea6
    Bug#33057164 mysql/mysql-server@d4e67f67356
    
    Problem:
    
    When executing a PREPARED statement,
    table performance_schema.threads does not populate the PROCESSLIST_INFO
    column.
    
    This prevents to properly observe the execution of prepared statements.
    
    This is also a regression, introduced in:
    - MySQL 5.6.46
    - MySQL 5.7.28
    - MySQL 8.0.18
    
    Root cause:
    
    The fix for:
      Bug 20712046 SHOW PROCESSLIST AND PERFORMANCE_SCHEMA TABLES DO NOT MASK PASSWORD FROM QUERY
    removed a call to PSI_THREAD_CALL(set_thread_info) located in THD::set_query()
    
    PSI_THREAD_CALL(set_thread_info) was called from different places in the
    same fix, to make sure a properly sanitized query text is displayed if
    needed, but the code path for prepared statements was overlooked.
    
    Fix:
    
    The fix is to call PSI_THREAD_CALL(set_thread_info) in the missing code
    path, when executing a prepared statement.
    
    The call uses either the executed query, or a sanitized version of it
    if it contains sensitive data.
    
    Additional fix:
    
    The logic around rewrite_query_if_needed() was revised.
    
    Trying to anticipate if a query will be displayed or not,
    to possibly save a rewrite, is too fragile, and too dangerous.
    
    Queries that contain sensitive data are always rewritten,
    regardless of whether the query will actually be printed somewhere or not.
    
    Change-Id: Ief9c80a24f539f0889371766843d2f7b05812ad8

diff --git a/include/mysql/psi/mysql_thread.h b/include/mysql/psi/mysql_thread.h
index b52ea13613f..e60560518fd 100644
--- a/include/mysql/psi/mysql_thread.h
+++ b/include/mysql/psi/mysql_thread.h
@@ -1329,6 +1329,15 @@ static inline void mysql_thread_set_peer_port(uint port MY_ATTRIBUTE ((unused)))
 
 #endif
 
+static inline void mysql_thread_set_info(
+  const char *str MY_ATTRIBUTE ((unused)),
+  int len MY_ATTRIBUTE ((unused)))
+{
+#ifdef HAVE_PSI_THREAD_INTERFACE
+  PSI_THREAD_CALL(set_thread_info)(str, len);
+#endif
+}
+
 #endif /* DISABLE_MYSQL_THREAD_H */
 
 /** @} (end of group Thread_instrumentation) */
diff --git a/mysql-test/suite/perfschema/include/rewritten_queries.inc b/mysql-test/suite/perfschema/include/rewritten_queries.inc
new file mode 100644
index 00000000000..7e37aa16b54
--- /dev/null
+++ b/mysql-test/suite/perfschema/include/rewritten_queries.inc
@@ -0,0 +1,49 @@
+
+#
+# Checks to perform after each query.
+#
+# Parameters:
+# - $con1_thread_id
+# - $con1_connection_id
+#
+
+--disable_query_log
+eval SELECT "thread" as mark, PROCESSLIST_INFO
+  FROM performance_schema.threads
+  WHERE THREAD_ID = $con1_thread_id;
+
+--echo ---------------------------------------
+
+eval SELECT "processlist" as mark, INFO
+  FROM performance_schema.processlist
+  WHERE ID = $con1_connection_id;
+
+--echo ---------------------------------------
+
+eval SELECT "I_S.PROCESSLIST" as mark, INFO
+  FROM INFORMATION_SCHEMA.PROCESSLIST
+  WHERE ID = $con1_connection_id;
+
+--echo ---------------------------------------
+
+eval SELECT "current" as mark, EVENT_NAME, SQL_TEXT, DIGEST_TEXT
+  FROM performance_schema.events_statements_current
+  WHERE THREAD_ID = $con1_thread_id;
+
+--echo ---------------------------------------
+
+eval SELECT "history" as mark, EVENT_NAME, SQL_TEXT, DIGEST_TEXT
+  FROM performance_schema.events_statements_history
+  WHERE THREAD_ID = $con1_thread_id
+  ORDER BY EVENT_ID;
+
+--echo ---------------------------------------
+
+eval SELECT "history_long" as mark, EVENT_NAME, SQL_TEXT, DIGEST_TEXT
+  FROM performance_schema.events_statements_history_long
+  WHERE THREAD_ID = $con1_thread_id
+  ORDER BY EVENT_ID;
+
+--echo ---------------------------------------
+
+--enable_query_log
